;here we put all 'basic' -Macros to use
; in all templates. This gives a 'quasi-stanbdard'.

CompilerIf Defined(__basic_macros__, #PB_Constant) = 0
  
  #__basic_macros__ = #True
  
;from Hellound
Macro __DQ()
  "
EndMacro

;from Hellhound
Macro _ASSERT(__EXPR)
  CompilerIf #PB_Compiler_Debugger
    If(__EXPR#)
      CompilerIf #PB_Compiler_OS=#PB_OS_Windows
        MessageRequester("ASSERTION!","Assertion failure"+#CRLF$+"'"+__DQ()__EXPR#__DQ()+"'"+#CRLF$+"Program termination at Line "+Str(#PB_Compiler_Line),#PB_MessageRequester_Ok|#MB_ICONERROR)
      CompilerElse
        MessageRequester("ASSERTION!","Assertion failure"+#CRLF$+"'"+__DQ()__EXPR#__DQ()+"'"+#CRLF$+"Program termination at Line "+Str(#PB_Compiler_Line),#PB_MessageRequester_Ok)
      CompilerEndIf
      CallDebugger
    EndIf
  CompilerEndIf
EndMacro


Macro _CHECK(__EXPR, __TEXT="")
  CompilerIf #PB_Compiler_Debugger
    If Not ( __EXPR#)
      Debug("Check failed at Line "+Str(#PB_Compiler_Line)+" :"+__TEXT )
    EndIf
  CompilerEndIf
EndMacro

;A very nice Macro from Hroudtwolf ; a little changed from me
Macro DoOrDie (_DIEMESSAGE_ , _CONDITIONCALL_)
  If Not( _CONDITIONCALL_)
    MessageRequester ("Message" , _DIEMESSAGE_ , #MB_OK|#MB_ICONERROR)
    End
  EndIf
EndMacro


Macro mcRandomMinMax( min , max )
  Random(max- min ) + min
EndMacro

Macro mcRandom_Float(min,max,res = 100)
  0.0+((Random( (max-min)*res) +(min*res))  / res)
EndMacro


Macro mcDHex( __VAL__ )
  "$"+RSet( Hex(__VAL__), 4, "0")
EndMacro


CompilerEndIf

; jaPBe Version=3.8.2.693
; Build=0
; FirstLine=23
; CursorPosition=51
; ExecutableFormat=Windows
; DontSaveDeclare
; EOF