
IncludeFile "prototypeLib.pbi"

IncludeFile "GridManager2d.pbi"



Global *testSprite.sGridObject2D
Global *grid.sGrid

  
Global NewList aliens.l()

;test.....
Procedure mainCallback(deltaTime.l, *MPOS.POINT, MLC.l, MRC.l )
  ;*** Simple Action ***
  If KeyboardPushed(#PB_Key_Space) Or MLC Or MRC
    If MLC
      Col = $2010C0
    ElseIf MRC
      Col = $10C020
    Else
      Col = $808080
    EndIf
    StartDrawing(ScreenOutput())
      FrontColor(Col)
      Circle(*MPOS\X,*MPOS\Y,32)
    StopDrawing()
    
    *testSprite\pos\X = *MPOS\X
    *testSprite\pos\Y = *MPOS\Y
    Start3D()
      GridObject2D_Draw(*testSprite)
      
      
    Stop3D()
    
    
    *testSprite\angle + (50.0/deltaTime)
    
    
  EndIf 
  
  GridObject2D_Update(*testSprite,delta)
  GridManager2D_Update(*grid) 
  
  StartDrawing(ScreenOutput())
    *llObj = GridManager2D_GetObjectsInMyZones(*grid, *testSprite)
    If CountList2(*llObj) > 0
      *testSprite\boxColor = #Blue
      DrawText(0,580,"Cols="+Str(CountList2(*llObj)),#White,#Black)
    Else
      *testSprite\boxColor = #Red 
    EndIf
    DeleteList2(*llObj)

    
    
    GridObject2D_DrawBounds(*testSprite)  
;    GridManager2D_DrawZones(*testSprite) 
;    GridObject2D_DrawBounds(*testSprite2)  
;    GridManager2D_DrawZones(*testSprite2) 
    GridManager2D_DrawZonesDebug(*grid)
    
  StopDrawing()
Start3D()  
  ForEach aliens()
    *alien.sGridObject2D = aliens()
    GridObject2D_Draw(*alien) 
  Next
  Stop3D()
    
  
  ProcedureReturn #False
EndProcedure

UsePNGImageDecoder()
prototypeInit(800,600,#True,"hurz",32)
#GRIDZONE=32

*grid = GridManager2D_Create(800/#GRIDZONE, 600/#GRIDZONE,#GRIDZONE,#GRIDZONE,"mygrid")

*testSprite = GridObject2D_Create("miau",-1)
GridObject2D_Load(*testSprite,"squeaker_bird.png")
GridManager2D_AddObject(*grid,*testSprite)

For i = 0 To 44
  AddElement(aliens())
  *alien.sGridObject2D = GridObject2D_Create("miau "+Str(i),-1)
  GridObject2D_Load(*alien,"squeaker_bird.png")
  *alien\pos\X = mcRandomMinMax(20,780)
  *alien\pos\Y = mcRandomMinMax(20,580)
  *alien\Size\cx = mcRandomMinMax(20,50)
  *alien\Size\cy = mcRandomMinMax(20,50)
  GridManager2D_AddObject(*grid,*alien)
  aliens() = *alien
Next
            
#GRIDZONE=32

prototypeMain(@mainCallback(),#Black,#True)

ForEach aliens()
  GridManager2D_RemoveObject(*grid,aliens())
  GridObject2D_Destroy(aliens()) 
Next

GridManager2D_RemoveObject(*grid,*testSprite)
GridObject2D_Destroy(*testSprite) 

GridManager2D_Free(*grid)




End


; jaPBe Version=3.8.2.693
; Build=1
; FirstLine=73
; CursorPosition=117
; ExecutableFormat=Windows
; Executable=T:\projects\pb4\GameWiz\AdditionalSources\GridExample.exe
; DontSaveDeclare
; EOF